Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.h	(revision 569)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.h	(revision 580)
@@ -16,4 +16,7 @@
 class VspKdLeaf;
 class KdLeaf;
+class ViewCellInterior;
+class MergeCandidate;
+class ViewCellsManager;
 
 /** Statistics for a view cell partition.
@@ -78,7 +81,10 @@
 };
 
+
 /**
 	View cell with an optional mesh representation
 */
+
+
 class ViewCell: public MeshInstance
 {
@@ -93,4 +99,5 @@
 	*/
 	virtual ~ViewCell() {}
+
 	/** Returns Pvs.
 	*/
@@ -100,4 +107,6 @@
 	int Type() const;
 
+	void SetParent(ViewCellInterior *parent);
+
 	/** Adds a passing ray to the passing ray container.
 	*/
@@ -124,16 +133,33 @@
 	virtual void UpdateViewCellsStats(ViewCellsStatistics &vcStat);
 
-	/// Ray set description of the rays passing through this node.
-	PassingRaySet mPassingRays;
+	/** if this view cell is the root of a view cell hierarchy
+	*/
+	bool IsRoot() const;
+
+	/** Returns parent view cell.
+	*/
+	ViewCellInterior *GetParent() const;
+
+	
+	/** Sets the mesh for this view cell.
+	*/
+	void SetMesh(Mesh *mesh);
+
+	void SetValid(const bool valid);
+	bool GetValid() const;
+
+
+
+
+	/// parent view cell in the view cell hierarchy
+	ViewCellInterior *mParent;
 
 	/// Rays piercing this view cell.
 	RayContainer mPiercingRays;
 
-	/** Sets the mesh for this view cell.
-	*/
-	void SetMesh(Mesh *mesh);
-
-	void SetValid(const bool valid);
-	bool GetValid() const;
+
+	/** if this is a view cell correspending to a leaf in a hierarchy.
+	*/
+	virtual bool IsLeaf() const = 0;
 
   static bool SmallerPvs(const ViewCell *a,
@@ -142,4 +168,27 @@
   }
 
+
+	void SetTimeStamp(const int timeStamp);
+	int GetTimeStamp() const;
+	static void NewMail(const int reserve = 1) {
+		sMailId += sReservedMailboxes;
+		sReservedMailboxes = reserve;
+	}
+	void Mail() { mMailbox = sMailId; }
+	bool Mailed() const { return mMailbox == sMailId; }
+
+	void Mail(const int mailbox) { mMailbox = sMailId + mailbox; }
+	bool Mailed(const int mailbox) const { return mMailbox == sMailId + mailbox; }
+
+	int IncMail() { return ++mMailbox - sMailId; }
+
+
+						 
+	// last mail id -> warning not thread safe!
+	// both mailId and mailbox should be unique for each thread!!!
+	static int sMailId;
+	static int sReservedMailboxes;
+	
+
 protected:
 
@@ -150,6 +199,26 @@
 	float mArea;
 
+	int mTimeStamp;
 
 	bool mValid;
+};
+
+
+class ViewCellInterior: public ViewCell
+{
+public:
+	ViewCellInterior();
+	~ViewCellInterior();
+
+	ViewCellInterior(Mesh *mesh);
+	
+
+	/** Sets pointer from parent to child and vice versa.
+	*/
+	void SetupChildLink(ViewCell *l);
+	bool IsLeaf() const;
+
+	ViewCellContainer mChildren;
+
 };
 
@@ -158,10 +227,11 @@
 */
 template<typename T>
-class HierarchyViewCell: public ViewCell
+class ViewCellLeaf: public ViewCell
 {
 public:
-	HierarchyViewCell<T>(): mLeaves(0) {}
-	HierarchyViewCell<T>(Mesh *mesh):
-		ViewCell(mesh), mLeaves(0) {}
+
+	ViewCellLeaf<T>(): mLeaf(NULL) {}
+	ViewCellLeaf<T>(Mesh *mesh):
+		ViewCell(mesh), mLeaf(NULL) {}
 
 	void UpdateViewCellsStats(ViewCellsStatistics &vcStat)
@@ -169,18 +239,284 @@
 		ViewCell::UpdateViewCellsStats(vcStat);
 
-		if ((int)mLeaves.size() > vcStat.maxLeaves)
-			vcStat.maxLeaves = (int)mLeaves.size();
-		vcStat.leaves += (int)mLeaves.size();
-	}
-
-	/// Leaves of the hierarchy which are part of this view cell.
-	std::vector<T> mLeaves;
-};
-
-
-typedef HierarchyViewCell<BspLeaf *> BspViewCell;
-typedef HierarchyViewCell<KdLeaf *> KdViewCell;
-typedef HierarchyViewCell<VspKdLeaf *> VspKdViewCell;
-
+		//if ((int)mLeaves.size() > vcStat.maxLeaves)
+		//	vcStat.maxLeaves = (int)mLeaves.size();
+		//vcStat.leaves += (int)mLeaves.size();
+	}
+
+	bool IsLeaf() const
+	{
+		return true;
+	}
+
+	/// Leaf of some hierarchy which is part of this view cell.
+	T mLeaf;
+};
+
+
+typedef ViewCellLeaf<BspLeaf *> BspViewCell;
+typedef ViewCellLeaf<KdLeaf *> KdViewCell;
+typedef ViewCellLeaf<VspKdLeaf *> VspKdViewCell;
+
+
+
+class ViewCellsTree
+{
+public:
+	ViewCellsTree(ViewCellsManager *vcm);
+	~ViewCellsTree();
+
+	/** Returns number of leaves this view cell consists of.
+	*/
+	int GetSize(ViewCell *vc) const;
+
+	/** Collects leaves corresponding to a view cell.
+	*/
+	void CollectLeaves(ViewCell *vc, ViewCellContainer &leaves) const;
+
+	/** Merges view cells according to some cost heuristics.
+	*/
+	int ConstructMergeTree(const VssRayContainer &rays, const ObjectContainer &objects);
+	
+	/** Refines view cells using shuffling, i.e., border leaves 
+		of two view cells are exchanged if the resulting view cells
+		are tested to be "better" than the old ones.
+		@returns number of refined view cells
+	*/
+	int RefineViewCells(const VssRayContainer &rays, const ObjectContainer &objects);
+
+	/** Compresses the pvs of the view cells.
+	*/
+	void CompressViewCellsPvs();
+
+	/** Returns optimal set of view cells for a given number of view cells.
+	*/
+	void CollectBestViewCellSet(ViewCellContainer &viewCells, const int numViewCells);
+
+protected:
+
+
+	//////////////////////////////////////////////////////////////
+	//                 merge options                            //
+	//////////////////////////////////////////////////////////////
+	
+
+	/** Returns cost of this leaf according to current heuristics.
+	*/
+	float GetCostHeuristics(ViewCell *vc) const;
+
+	/** Returns cost of leaf.
+	*/
+	float GetRenderCost(ViewCell *vc) const;
+
+	/** Evaluates the merge cost of this merge candidate pair.
+	*/
+	void EvalMergeCost(MergeCandidate &mc) const;
+
+	/** Variance of leaf.
+	*/
+	float GetVariance(ViewCell *vc) const;
+
+	/** Standard deviation of leaf.
+	*/
+	float GetDeviation(ViewCell *vc) const;
+
+	/** Recalculates this merge candidate and sets valid.
+	*/
+	void SetMergeCandidateValid(MergeCandidate &mc) const;
+
+	/** Merge view cells of leaves l1 and l2.
+		@returns difference in pvs size
+	*/
+	ViewCellInterior *MergeViewCells(ViewCell *l, ViewCell *r, int &pvsDiff); //const;
+
+	/** Shuffles, i.e. takes border leaf from view cell 1 and adds it 
+		to view cell 2.
+	*/
+	void ShuffleLeaf(ViewCell *leaf, ViewCell *vc1, ViewCell *vc2) const;	
+		
+	/** Shuffles the leaves, i.e., tests if exchanging
+		the leaves helps in improving the view cells.
+	*/
+	bool ShuffleLeaves(ViewCell *l, ViewCell *r) const;
+
+	/** Calculates cost for merge of view cell 1 and 2.
+	*/
+	float EvalShuffleCost(ViewCell *leaf, ViewCell *vc1, ViewCell *vc2) const;
+
+	/** Exports a snapshot of the merged view cells to disc.
+	*/
+	void ExportMergedViewCells(ViewCellContainer &viewCells, 
+							   const ObjectContainer &objects,
+							   const int numNewViewCells);
+
+
+
+	/** merge queue must be reset after some time because expected value
+		may not be valid.
+	*/
+	void ResetMergeQueue();
+
+	/** Updates the current top level of view cells.
+	*/
+	int UpdateMergedViewCells(ViewCellContainer &viewCells);
+
+
+
+	ViewCellsManager *mViewCellsManager;
+	ViewCell *mRoot;
+
+	/// if merge visualization should be shown
+	bool mExportMergedViewCells;
+
+	
+		
+	ViewCellContainer mInactiveViewCells;
+	ViewCellContainer mActiveViewCells;
+
+	/// weights between variance and render cost increase (must be between zero and one)
+	float mRenderCostWeight;
+
+	/// overall cost used to normalize cost ratio
+	float mOverallCost;
+	float mExpectedCost;
+    float mDeviation;
+	float mAvgRenderCost;
+
+	int mUseAreaForPvs;
+
+	int mNumViewCells;
+
+	/// minimal number of view cells
+	int mMergeMinViewCells;
+	/// maximal cost ratio for the merge
+	float mMergeMaxCostRatio;
+
+	ofstream mStats;
+
+	typedef priority_queue<MergeCandidate> MergeQueue;
+
+	MergeQueue mMergeQueue;
+
+	
+
+};
+
+
+/**
+	Candidate for leaf merging based on priority.
+*/
+class MergeCandidate
+{  
+	friend class ViewCellsTree;
+
+public:
+
+	MergeCandidate(ViewCell *l, ViewCell *r);
+
+	/** If this merge pair is still valid.
+	*/
+	bool IsValid() const;
+
+	
+	friend bool operator<(const MergeCandidate &leafa, const MergeCandidate &leafb)
+	{
+		return leafb.GetMergeCost() < leafa.GetMergeCost();
+	}
+
+	void SetLeftViewCell(ViewCell *l);
+	void SetRightViewCell(ViewCell *l);
+
+	ViewCell *GetLeftViewCell() const;
+	ViewCell *GetRightViewCell() const;
+
+	ViewCell *GetInitialLeftViewCell() const;
+	ViewCell *GetInitialRightViewCell() const;
+
+	/** Returns the increase of the standard deviation of this merge candidate.
+	*/
+	float GetDeviationIncr() const;
+
+	/** Merge cost of this candidate pair.
+	*/
+	float GetMergeCost() const;
+
+	/** Render cost of this candidate.
+	*/
+	float GetRenderCost() const;
+	
+	static float sRenderCostWeight;
+
+protected:
+
+	/// render cost increase by this merge
+	float mRenderCost;
+	/// increase / decrease of standard deviation
+	float mDeviationIncr;
+
+	ViewCell *mLeftViewCell;
+	ViewCell *mRightViewCell;
+
+	ViewCell *mInitialLeftViewCell;
+	ViewCell *mInitialRightViewCell;
+};
+
+
+class MergeStatistics: public StatisticsBase
+{
+public:
+	
+	int merged;
+	int siblings;
+	int candidates;
+	int nodes;
+
+	int accTreeDist;
+	int maxTreeDist;
+	
+	Real collectTime;
+	Real mergeTime;
+
+	Real overallCost;
+
+	Real expectedRenderCost;
+	Real deviation;
+	Real heuristics;
+
+	// Constructor
+	MergeStatistics() 
+	{
+		Reset();
+	}
+	
+	double AvgTreeDist() const {return (double)accTreeDist / (double)merged;}; 
+
+	void Reset() 
+	{
+		nodes = 0;
+		merged = 0;
+		siblings = 0;
+		candidates = 0;
+	
+		accTreeDist = 0;
+		maxTreeDist = 0;
+
+		collectTime = 0;
+		mergeTime = 0;
+		overallCost = 0;
+
+		expectedRenderCost = 0;
+		deviation = 0;
+		heuristics = 0;
+
+	}
+
+	void Print(ostream &app) const;
+
+	friend ostream &operator<<(ostream &s, const MergeStatistics &stat) 
+	{
+		stat.Print(s);
+		return s;
+	} 
+};
 
 #endif
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp	(revision 574)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp	(revision 580)
@@ -94,5 +94,5 @@
 		ViewCell *vc = *it;
 
-		const bool valid = !vc->GetValid();
+		const bool valid = vc->GetValid();
 	
 
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.cpp	(revision 564)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.cpp	(revision 580)
@@ -850,5 +850,5 @@
 		{
 			ViewCell *vc = dynamic_cast<BspLeaf *>(node)->GetViewCell();
-     
+#if 0     
 			// set the mesh material according to the ray density
 			if (vc->mPassingRays.mRays) 
@@ -860,6 +860,9 @@
 				mForcedMaterial.mDiffuseColor.g = 1.0f - mForcedMaterial.mDiffuseColor.r;
 				ExportViewCell(vc);
+
 			}
-		} else 
+#endif
+		} 
+		else 
 		{
 			BspInterior *interior = (BspInterior *)node;
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.cpp	(revision 577)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.cpp	(revision 580)
@@ -356,5 +356,5 @@
 	{
 		// TODO: get view cell with specified id
-		ViewCell dummyVc;
+		BspViewCell dummyVc;
 		dummyVc.SetId(viewCellId);
 
@@ -363,4 +363,5 @@
 			
 		BspViewCell *viewCell = dynamic_cast<BspViewCell *>(*vit);
+
 		if (viewCell->GetId() == viewCellId)
 		{
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VspKdTree.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VspKdTree.h	(revision 517)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VspKdTree.h	(revision 580)
@@ -43,9 +43,9 @@
 	Candidate for leaf merging based on priority.
 */
-class MergeCandidate
+class VspKdMergeCandidate
 {  
 public:
 
-	MergeCandidate(VspKdLeaf *l1, VspKdLeaf *l2);
+	VspKdMergeCandidate(VspKdLeaf *l1, VspKdLeaf *l2);
 
 	/** Computes PVS difference between the leaves.
@@ -61,5 +61,5 @@
 	void SetValid();
 
-	friend bool operator<(const MergeCandidate &leafa, const MergeCandidate &leafb)
+	friend bool operator<(const VspKdMergeCandidate &leafa, const VspKdMergeCandidate &leafb)
 	{
 		return leafb.GetMergeCost() < leafa.GetMergeCost();
@@ -850,5 +850,5 @@
 	ViewCellsManager *mViewCellsManager;
 
-	priority_queue<MergeCandidate> mMergeQueue;
+	priority_queue<VspKdMergeCandidate> mMergeQueue;
 
 
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 579)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 580)
@@ -33,4 +33,6 @@
 	mViewSpaceBox.Initialize();
 	ParseEnvironment();
+
+	mViewCellsTree = new ViewCellsTree(this);
 }
 
@@ -53,4 +55,6 @@
 
 	environment->GetBoolValue("ViewCells.exportToFile", mExportViewCells);
+
+	environment->GetBoolValue("ViewCells.PostProcess.useRaysForMerge", mUseRaysForMerge);
 
 	mMinPvsSize = emptyViewCells ? 1 : 0;
@@ -75,5 +79,7 @@
 {
 	DEL_PTR(mRenderer);
-	CLEAR_CONTAINER(mViewCells);
+	//CLEAR_CONTAINER(mViewCells);
+	DEL_PTR(mViewCellsTree);
+
 	CLEAR_CONTAINER(mMeshContainer);
 }
@@ -302,5 +308,5 @@
 float ViewCellsManager::GetViewSpaceVolume()
 {
-	return mViewSpaceBox.GetVolume()*(2.0f*sqr(M_PI));
+	return mViewSpaceBox.GetVolume()*(2.0f*sqr((float)M_PI));
 }
 
@@ -356,27 +362,35 @@
 
 
-void ViewCellsManager::EvaluateRenderStatistics(float &totalRenderCost, 
+void ViewCellsManager::EvaluateRenderStatistics(float &totalRenderCost,
 												float &expectedRenderCost, 
-												float &variance)
+												float &deviation,
+												float &variance,
+												int &totalPvs,
+												float &avgRenderCost)
 {
 	ViewCellContainer::const_iterator it, it_end = mViewCells.end();
 
+
 	//-- compute expected value
 
 	totalRenderCost = 0;
+	totalPvs = 0;
 
 	for (it = mViewCells.begin(); it != it_end; ++ it)
 	{
 		ViewCell *vc = *it;
-
 		totalRenderCost += vc->GetPvs().GetSize() * vc->GetVolume();
-	}
-
+		totalPvs += (int)vc->GetPvs().GetSize();
+	}
+
+	// normalize with view space box
+	totalRenderCost /= mViewSpaceBox.GetVolume();
 	expectedRenderCost = totalRenderCost / (float)mViewCells.size();
-
-
-	//-- compute variance
-	
+	avgRenderCost = totalPvs / (float)mViewCells.size();
+
+
+	//-- compute standard defiation
 	variance = 0;
+	deviation = 0;
 
 	for (it = mViewCells.begin(); it != it_end; ++ it)
@@ -385,11 +399,17 @@
 
 		float renderCost = vc->GetPvs().GetSize() * vc->GetVolume();
-
-		const float var = (expectedRenderCost - renderCost) * (expectedRenderCost - renderCost);
-
-		variance += var;
-	}
-	
+		float dev;
+
+		if (1)
+			dev = fabs(avgRenderCost - (float)vc->GetPvs().GetSize());
+		else
+			dev = fabs(expectedRenderCost - renderCost);
+
+		deviation += dev;
+		variance += dev * dev;
+	}
+
 	variance /= (float)mViewCells.size();
+	deviation /= (float)mViewCells.size();
 }
 
@@ -493,23 +513,28 @@
 
 
-ViewCell *ViewCellsManager::MergeViewCells(ViewCell &front, ViewCell &back) const
-{
-	// generate merged view cell
-	ViewCell *vc = GenerateViewCell();
+ViewCellInterior *ViewCellsManager::MergeViewCells(ViewCell &left, ViewCell &right) const
+{
+	// generate parent view cell
+	ViewCellInterior *vc = new ViewCellInterior();//GenerateViewCell();
 
 	// merge pvs
-	vc->GetPvs().Merge(front.GetPvs(), back.GetPvs());
+	vc->GetPvs().Merge(left.GetPvs(), right.GetPvs());
 
 	//-- merge ray sets
 	if (0)
 	{
-		stable_sort(front.mPiercingRays.begin(), front.mPiercingRays.end());
-		stable_sort(back.mPiercingRays.begin(), back.mPiercingRays.end());
-
-		std::merge(front.mPiercingRays.begin(), front.mPiercingRays.end(),
-				   back.mPiercingRays.begin(), back.mPiercingRays.end(),
+		stable_sort(left.mPiercingRays.begin(), left.mPiercingRays.end());
+		stable_sort(right.mPiercingRays.begin(), right.mPiercingRays.end());
+
+		std::merge(left.mPiercingRays.begin(), left.mPiercingRays.end(),
+				   right.mPiercingRays.begin(), right.mPiercingRays.end(),
 				   vc->mPiercingRays.begin());
 	}
 
+
+	vc->SetupChildLink(&left);
+	vc->SetupChildLink(&right);
+
+
 	return vc;
 }
@@ -522,7 +547,7 @@
 
 
-ViewCell *ViewCellsManager::GenerateViewCell(Mesh *mesh) const
-{
-	return new ViewCell(mesh);
+ViewCellsTree *ViewCellsManager::GetViewCellsTree()
+{
+	return mViewCellsTree;
 }
 
@@ -814,5 +839,5 @@
 		{
 			ExportColor(exporter, *it);
-			ExportVcGeometry(exporter, *it);
+			ExportViewCellGeometry(exporter, *it);
 		}
 	}
@@ -1186,16 +1211,11 @@
 
 		Debug << i << ": pvs size=" << (int)vc->GetPvs().GetSize()
-			  << ", piercing rays=" << (int)vcRays.size()
-			  << ", leaves=" << (int)vc->mLeaves.size() << endl;
+			  << ", piercing rays=" << (int)vcRays.size() << endl;
+			 // << ", leaves=" << (int)vc->mLeaves.size() << endl;
 
 
 		// export rays piercing this view cell
-#if 0
 		exporter->ExportRays(vcRays, RgbColor(0, 1, 0));
-#else
-		vector<BspLeaf *>::const_iterator lit, lit_end = vc->mLeaves.end();
-		for (lit = vc->mLeaves.begin(); lit != lit_end; ++ lit)
-			exporter->ExportRays((*lit)->mVssRays);
-#endif
+
 		m.mDiffuseColor = RgbColor(1, 0, 0);
 		exporter->SetForcedMaterial(m);
@@ -1249,5 +1269,5 @@
 		{
 			BspViewCell *vc = dynamic_cast<BspViewCell *>(*vit);
-			ray->intersections.push_back(BspIntersection(0, vc->mLeaves[0]));
+			ray->intersections.push_back(BspIntersection(0, vc->mLeaf));
 		}
 
@@ -1278,7 +1298,5 @@
 	case 2: // merges
 		{
-			BspViewCell *bspVc = dynamic_cast<BspViewCell *>(vc);
-
-			importance = (float)bspVc->mLeaves.size() /
+			importance = (float)mViewCellsTree->GetSize(vc) /
 				(float)mViewCellsStats.maxLeaves;
 		}
@@ -1301,5 +1319,5 @@
 }
 
-void BspViewCellsManager::ExportVcGeometry(Exporter *exporter,
+void BspViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
 										 ViewCell *vc) const
 {
@@ -1332,4 +1350,11 @@
   return mBspTree->GetViewCell(point);
 }
+
+
+void BspViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, vector<MergeCandidate> &candidates)
+{
+	// TODO
+}
+
 
 /**********************************************************************/
@@ -1585,13 +1610,24 @@
 }
 
-
-void KdViewCellsManager::ExportVcGeometry(Exporter *exporter,
-										  ViewCell *vc) const
-{
-	KdViewCell *kdVc = dynamic_cast<KdViewCell *>(vc);
-	vector<KdLeaf *>::const_iterator it, it_end = kdVc->mLeaves.end();
-
-	for (it = kdVc->mLeaves.begin(); it != it_end; ++ it)
-		exporter->ExportBox(mKdTree->GetBox(*it));
+ViewCell *KdViewCellsManager::GenerateViewCell(Mesh *mesh) const
+{
+	return new KdViewCell(mesh);
+}
+
+
+void KdViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
+												ViewCell *vc) const
+{
+	ViewCellContainer leaves;
+
+	mViewCellsTree->CollectLeaves(vc, leaves);
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+	for (it = leaves.begin(); it != it_end; ++ it)
+	{
+		KdViewCell *kdVc = dynamic_cast<KdViewCell *>(*it);
+	
+		exporter->ExportBox(mKdTree->GetBox(kdVc->mLeaf));
+	}
 }
 
@@ -1625,4 +1661,13 @@
 	// TODO
 }
+
+
+
+void KdViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, 
+												vector<MergeCandidate> &candidates)
+{
+	// TODO
+}
+
 
 /**********************************************************************/
@@ -1798,15 +1843,20 @@
 		exporter->SetWireframe();
 
-		ExportVcGeometry(exporter, vc);
+		ExportViewCellGeometry(exporter, vc);
 
 		//-- export stored rays
+		
 		if (mExportRays)
 		{
-			vector<VspKdLeaf *>::const_iterator it,
-				it_end = vc->mLeaves.end();
-
-			for (it = vc->mLeaves.begin(); it != it_end; ++ it)
+			ViewCellContainer leaves;
+			mViewCellsTree->CollectLeaves(vc, leaves);
+
+			ViewCellContainer::const_iterator it,
+				it_end = leaves.end();
+
+			for (it = leaves.begin(); it != it_end; ++ it)
 			{
-				VspKdLeaf *leaf = *it;
+				VspKdViewCell *vspKdVc = dynamic_cast<VspKdViewCell *>(*it);
+				VspKdLeaf *leaf = vspKdVc->mLeaf;
 				AxisAlignedBox3 box = mVspKdTree->GetBBox(leaf);
 
@@ -1834,5 +1884,5 @@
 			}
 		}
-
+	
 		//-- output PVS of view cell
 		m.mDiffuseColor = RgbColor(1, 0, 0);
@@ -1927,9 +1977,8 @@
 		}
 		break;
-	case 2: // merges
-		{
-            VspKdViewCell *vspKdVc = dynamic_cast<VspKdViewCell *>(vc);
-
-			importance = (float)vspKdVc->mLeaves.size() /
+	case 2: // merged leaves
+		{
+        	int lSize = mViewCellsTree->GetSize(vc);
+			importance = (float)lSize /
 				(float)mViewCellsStats.maxLeaves;
 		}
@@ -1954,14 +2003,20 @@
 
 
-void VspKdViewCellsManager::ExportVcGeometry(Exporter *exporter,
+void VspKdViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
 										   ViewCell *vc) const
 {
 	VspKdViewCell *kdVc = dynamic_cast<VspKdViewCell *>(vc);
-	vector<VspKdLeaf *>::const_iterator it, it_end = kdVc->mLeaves.end();
 
 	Mesh m;
-	for (it = kdVc->mLeaves.begin(); it != it_end; ++ it)
-	{
-		mVspKdTree->GetBBox(*it).AddBoxToMesh(&m);
+
+	ViewCellContainer leaves;
+	mViewCellsTree->CollectLeaves(vc, leaves);
+
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+	for (it = leaves.begin(); it != it_end; ++ it)
+	{
+		VspKdLeaf *l = dynamic_cast<VspKdViewCell *>(*it)->mLeaf;
+		mVspKdTree->GetBBox(l).AddBoxToMesh(&m);
 	}
 
@@ -1975,4 +2030,9 @@
 }
 
+
+void VspKdViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, vector<MergeCandidate> &candidates)
+{
+	// TODO
+}
 
 
@@ -2131,6 +2191,7 @@
 	long startTime = GetTime();
 
+	
 	// TODO: should be done BEFORE the ray casting
-	merged = mVspBspTree->MergeViewCells(rays, objects);
+	merged = mViewCellsTree->ConstructMergeTree(rays, objects);
 
 	//-- stats and visualizations
@@ -2194,5 +2255,5 @@
 
 	// refining the merged view cells
-	const int refined = mVspBspTree->RefineViewCells(rays, objects);
+	const int refined = mViewCellsTree->RefineViewCells(rays, objects);
 
 	//-- stats and visualizations
@@ -2234,4 +2295,5 @@
 	mViewCellsStats.Reset();
 	EvaluateViewCellsStats();
+
 	// has to be recomputed
 	mTotalAreaValid = false;
@@ -2254,6 +2316,24 @@
 	//-- merge the individual view cells
 	MergeViewCells(postProcessRays, objects);
+
 	//-- refines the merged view cells
 	RefineViewCells(postProcessRays, objects);
+
+	if (1)
+	{		
+		float totalCost, erc, var, dev, avg;
+		int totalpvs;
+
+		mViewCellsStats.Reset();
+
+        EvaluateRenderStatistics(totalCost, erc, dev, var, totalpvs, avg);
+		
+		Debug << "statistics after merge "  
+			  << " erc: " << erc 
+			  << " dev: " << dev
+			  << " totalpvs: " << totalpvs 
+			  << " avg: " << avg << endl;
+	}
+
 
 	//-- export shuffled view cells
@@ -2293,9 +2373,13 @@
 				vm.mDiffuseColor.b -= 0.45f;
 
-				vector<BspLeaf *>::const_iterator lit, lit_end = vc->mLeaves.end();
-
-				for (lit = vc->mLeaves.begin(); lit != lit_end; ++ lit)
+
+				ViewCellContainer leaves;
+				mViewCellsTree->CollectLeaves(vc, leaves);
+
+				ViewCellContainer::const_iterator lit, lit_end = leaves.end();
+
+				for (lit = leaves.begin(); lit != lit_end; ++ lit)
 				{
-					BspLeaf *leaf = *lit;
+					BspLeaf *leaf = dynamic_cast<BspViewCell *>(*lit)->mLeaf;
 
 					if (leaf->Mailed())
@@ -2391,9 +2475,10 @@
 	if (1) // export view cells
 	{
-		cout << "exporting view cells after post process ... ";
 		Exporter *exporter = Exporter::GetExporter("final_view_cells.x3d");
 
 		if (exporter)
 		{
+			cout << "exporting view cells after post process ... ";
+
 			if (1)
 			{
@@ -2416,4 +2501,5 @@
 			ExportViewCellsForViz(exporter);
 			delete exporter;
+			cout << "finished" << endl;
 		}
 	}
@@ -2446,9 +2532,12 @@
 				BspViewCell *vc = dynamic_cast<BspViewCell *>(*vit);
 
-				vector<BspLeaf *>::const_iterator lit, lit_end = vc->mLeaves.end();
-
-				for (lit = vc->mLeaves.begin(); lit != lit_end; ++ lit)
+				ViewCellContainer leaves;
+				mViewCellsTree->CollectLeaves(vc, leaves);
+
+				ViewCellContainer::const_iterator lit, lit_end = leaves.end();
+
+				for (lit = leaves.begin(); lit != lit_end; ++ lit)
 				{
-					BspLeaf *leaf = *lit;
+					BspLeaf *leaf = dynamic_cast<BspViewCell *>(*lit)->mLeaf;
 
 					Material m; 
@@ -2573,5 +2662,5 @@
 				{
 					BspViewCell *bspVc = dynamic_cast<BspViewCell *>(ray->mViewCells[j]);
-					BspLeaf *leaf = bspVc->mLeaves[0];
+					BspLeaf *leaf = bspVc->mLeaf;
 					if (vc == bspVc)
 						vcRays.push_back(ray);
@@ -2589,10 +2678,10 @@
 		exporter->SetForcedMaterial(m);
 
-		ExportVcGeometry(exporter, vc);
+		ExportViewCellGeometry(exporter, vc);
 
 
 		Debug << i << ": pvs size=" << (int)vc->GetPvs().GetSize()
-			  << ", piercing rays=" << (int)vcRays.size()
-			  << ", leaves=" << (int)vc->mLeaves.size() << endl;
+			  << ", piercing rays=" << (int)vcRays.size() << endl;
+			//  << ", leaves=" << (int)vc->mLeaves.size() << endl;
 
 		
@@ -2604,8 +2693,15 @@
 		else
 		{
-			vector<BspLeaf *>::const_iterator lit, lit_end = vc->mLeaves.end();
-
-			for (lit = vc->mLeaves.begin(); lit != lit_end; ++ lit)
-				exporter->ExportRays((*lit)->mVssRays);
+
+			ViewCellContainer leaves;
+			mViewCellsTree->CollectLeaves(vc, leaves);
+
+			ViewCellContainer::const_iterator lit, lit_end = leaves.end();
+
+			for (lit = leaves.begin(); lit != lit_end; ++ lit)
+			{
+				BspLeaf *l = dynamic_cast<BspViewCell *>(*lit)->mLeaf;
+				exporter->ExportRays(l->mVssRays);
+			}
 		}
 
@@ -2686,8 +2782,7 @@
 	case 2: // merges
 		{
-            BspViewCell *bspVc = dynamic_cast<BspViewCell *>(vc);
-
-			importance = (float)bspVc->mLeaves.size() /
-				(float)mViewCellsStats.maxLeaves;
+            int lSize = mViewCellsTree->GetSize(vc);
+	
+			importance = (float)lSize / (float)mViewCellsStats.maxLeaves;
 		}
 		break;
@@ -2713,5 +2808,5 @@
 
 
-void VspBspViewCellsManager::ExportVcGeometry(Exporter *exporter,
+void VspBspViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
 											  ViewCell *vc) const
 {
@@ -2731,16 +2826,19 @@
 int VspBspViewCellsManager::GetMaxTreeDiff(ViewCell *vc) const
 {
-	BspViewCell *bspVc = dynamic_cast<BspViewCell *>(vc);
+	ViewCellContainer leaves;
+	mViewCellsTree->CollectLeaves(vc, leaves);
+
 
 	int maxDist = 0;
+	
 	// compute max height difference
-	for (int i = 0; i < (int)bspVc->mLeaves.size(); ++ i)
-		for (int j = 0; j < (int)bspVc->mLeaves.size(); ++ j)
-	{
-		BspLeaf *leaf = bspVc->mLeaves[i];
+	for (int i = 0; i < (int)leaves.size(); ++ i)
+		for (int j = 0; j < (int)leaves.size(); ++ j)
+	{
+		BspLeaf *leaf = dynamic_cast<BspViewCell *>(leaves[i])->mLeaf;
 
 		if (i != j)
 		{
-			BspLeaf *leaf2 = bspVc->mLeaves[j];
+			BspLeaf *leaf2 =dynamic_cast<BspViewCell *>(leaves[j])->mLeaf;
 			int dist = mVspBspTree->TreeDistance(leaf, leaf2);
 			if (dist > maxDist)
@@ -2748,4 +2846,5 @@
 		}
 	}
+
 	return maxDist;
 }
@@ -2871,13 +2970,16 @@
 	CreateMesh(vc);
 
-	vector<BspLeaf *>::const_iterator it, it_end = vc->mLeaves.end();
-
 	float area = 0;
 	float volume = 0;
 
-	for (it = vc->mLeaves.begin(); it != it_end; ++ it)
+	ViewCellContainer leaves;
+	mViewCellsTree->CollectLeaves(vc, leaves);
+
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+	for (it = leaves.begin(); it != it_end; ++ it)
 	{
 		BspNodeGeometry geom;
-		BspLeaf *leaf = *it;
+		BspLeaf *leaf = dynamic_cast<BspViewCell *>(*it)->mLeaf;
 		mVspBspTree->ConstructGeometry(leaf, geom);
 
@@ -2898,5 +3000,27 @@
 
 
-//////////////////////////////////77
+
+void VspBspViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, 
+													vector<MergeCandidate> &candidates)
+{	
+	cout << "collecting merge candidates ... " << endl;
+
+	if (mUseRaysForMerge)
+	{
+		mVspBspTree->CollectMergeCandidates(rays, candidates);
+	}
+	else
+	{
+		vector<BspLeaf *> leaves;
+		mVspBspTree->CollectLeaves(leaves);
+		mVspBspTree->CollectMergeCandidates(leaves, candidates);
+	}
+
+	cout << "fininshed collecting candidates" << endl;
+}
+
+
+
+//////////////////////////////////
 ViewCellsManager *ViewCellsManagerFactory::Create(const string mName)
 {
@@ -2904,2 +3028,3 @@
 	return NULL;// new VspBspViewCellsManager();
 }
+
